REM speedta4.bas - a Qbasic program to generate a half wpm table for
REM the Morse Code Speedometer program - speedf84.asm
REM  The table is output to a file in a format which can be inserted or
REM     included into the speedometer PIC program (sfter it has been
REM     edited to take out some of the spaces).
REM
REM
REM  01/10/2001 Chuck Olson, WB9KZY
REM             Jackson Harbor Press
REM             http://jacksonharbor.home.att.net/
REM             jacksonharbor@att.net
REM
REM     altered 11/25/2000 to change to a .01 ms increment - this means that
REM                     the minimum speed had to be upped to 5 wpm because
REM                     cint can't handle an integer larger than 32k
REM     altered 01/08/2000 - added an addition .0 or .5 digit of precision
REM                     by doubling the table size - changed the structure
REM                     of the table into two seperate tables high and low
REM     altered 01/10/2000 - upped the top from 99 to 99.5 - also changed
REM                     the limits from .5 to .75 - also altered the lower
REM                     starting point to 3.75
REM
    INPUT "Enter halfwpm table output filename (high byte): "; n$
    OPEN n$ FOR OUTPUT AS #1
    INPUT "Enter halfwpm table output filename (low byte):"; n$
    OPEN n$ FOR OUTPUT AS #2
FOR i = 3.75 TO 99.75 STEP .5
REM Calculate the dit interval in hundreths of a millisecond
z = (1.2 / i) * 100000
REM Round and integerize the interval
y = CINT(z)
REM Split the interval into two table entries
REM first, x calculates the upper byte by calculating 256 chunks in the interval
x = INT(y / 256)
REM second, w subtracts the upper byte * 256 from the interval to get the
REM  lower byte
w = y - (256 * x)
REM "print" the results to a file in the retlw table format.
REM     retlw is a return from a subroutine call with the value specified
REM     in the w register.
    PRINT #1, "        retlw   d'"; x; "'   ;"; i; "wpm    "; CINT(z); "x .01 ms - high"
    PRINT #2, "        retlw   d'"; w; "'   ;"; i; "wpm    "; CINT(z); "x .01 ms - low"
NEXT i
CLOSE


